// 013 u_ib_create_table
// 25 mar 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_ib_create_table;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  IBCustomDataSet, IBQuery, IBDatabase, IBTable;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    IBQuery2: TIBQuery;
    IBQuery3: TIBQuery;
    Panel2: TPanel;
    create_table_: TButton;
    select_: TButton;
    drop_table_: TButton;
    open_database_: TButton;
    Panel1: TPanel;
    Memo1: TMemo;
    DBGrid1: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure create_table_Click(Sender: TObject);
    procedure select_Click(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
    procedure open_database_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    ;

{$R *.DFM}


    // k_connection_string= 127.0.0.1:C:\programs\interbase\data\Institut_Pascal.GDB

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.open_database_Click(Sender: TObject);
      begin
        with IbDatabase1 do
        begin
          Open;
          display(DataBaseName);
          Display(IntToStr(SqlDialect));
        end;
      end; // open_database_Click

    procedure TForm1.create_table_Click(Sender: TObject);
      begin
        with IbQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('CREATE TABLE formations');
            Add('  ('
                +'    f_numero INTEGER,');
            Add('     f_nom CHAR(23),');
            Add('     f_jours SMALLINT,');
            Add('     f_prix NUMERIC(5, 2)');
            Add('   )');
          end; // with Sql

          display_strings(Sql);

          Try
            IbDatabase1.Open;

            display(IbDatabase1.DefaultTransaction.Name);

            if IbDatabase1.DefaultTransaction.Active
              then display('active')
              else display('closed');

            display('Commit_previous');

            if ibtransaction1.InTransaction
              then ibTransaction1.Commit;

            display('StartTransaction');
            ibtransaction1.StartTransaction;

            if IbDatabase1.DefaultTransaction.Active
              then display('active')
              else display('closed');

            display('Exec');
            ExecSql;

            display('Commit');
            ibtransaction1.Commit;

            display('  ok');
          except
            on e: Exception do
              display('  *** pb_create '+ e.Message);
          end;
        end; // with IbQuery1
      end; // create_table_Click

    procedure TForm1.select_Click(Sender: TObject);
      begin
        with IbQuery2 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('SELECT * FROM formations');
            display_strings(Sql);

            Try
              Open;
              display('  ok');
            except
              on e: Exception do
                display('  *** pb '+ e.Message);
            end;
          end; // with Sql
        end; // with IbQuery2
      end; // select_Click

    procedure TForm1.drop_table_Click(Sender: TObject);
      begin
        IbDatabase1.Open;

        with IbQuery3 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('DROP TABLE formations');
          end; // with Sql

          display_strings(Sql);

          Try
            if ibtransaction1.InTransaction
              then ibTransaction1.Commit;

            ibtransaction1.StartTransaction;
            ExecSql;
            ibtransaction1.Commit;
            display('  ok');
          except
            on e: exception do
               display('  *** pb_drop '+ e.Message);
          end;
        end; // with IbQuery3
      end; // drop_table_Click

    end.


